//This adds a new o2 sensor definition to BRE

using System;
using System.Windows.Forms;

using bre20;
//css_reference ..\bre.exe;

namespace BensScripts
{
	public class NewO2Def
	{
		public static object AppliesTo(){return "all";}
		public static object ScriptTitle(){return "New O2 Def by Ben Ogle";}
		//args[1] = child window of type bre20.child
		public object ScriptMain(params object[] args)
		{
			((child)args[1]).subscribeToEvent("OnDataloggerCreated", "BensScripts.NewO2Def.log_Opened");
			return null;
		}
		public object log_Opened(params object[] args)
		{
			if(args[2] == null)
				return null;

			((Logger)args[2]).addO2Type(new NewO2Rule("My New O2"));

			return null;
		}
	}//end class

	public class NewO2Rule: AfrRule
	{
		//stuff we can use:
		//index
		public NewO2Rule(string name):base(name){
		}

		public override bool executeRule(Form frm)
		{
			Logger lo = ((Logger)frm);
			
			//is it our o2 type? if not return false
			if(index != lo.getO2Type()) return false;
			
			//get value from the hash table
			Integer val = (Integer)lo.getLoggerData().getHashtable()["o2afr"];

			//if its null, return false
			if(val == null) return false;

			//do calc stuff here:
			float afr = (float)(val.Value)/2.0f;

			//set the afr for the rest of the Logger
			lo.setAfr(afr);

			return true;
		}
	}
}//end namespace