

using System;
using System.Windows.Forms;

using bre20;
//css_reference ..\bre.exe;
//css_import IACVAdjustDlg.cs;

namespace BensScripts
{
	public class IACVDutyCycle
	{
		private static int PR3ADD = 0x33e8;
		private static int EPW0ADD = 0x3ac6;
		private static int JPW0ADD = 0x3aac;
		private child romWind;
		private int iacvadd;
		private IACVAdjustDlg dlg;

		public static object AppliesTo(){return "pr3:pw0";}
		public static object ScriptTitle(){return "IACV duty cycle edit by Ben Ogle";}

		//args[1] = child window of type bre20.child
		public object ScriptMain(params object[] args)
		{
			romWind = (child)args[1];
			string str = romWind.getRomType();
			if(Common.isMatch("jdm pw0",str,false))
				iacvadd = JPW0ADD;
			else if(Common.isMatch("euro pw0",str,false))
				iacvadd = EPW0ADD;
			else //if(Common.isMatch("pr3",str,false))
				iacvadd = PR3ADD;

			MenuItem item = romWind.AddMenuItem("Scripts", "IACV Duty Cycle Adjust", "BensScripts.IACVDutyCycle.mnu_click");
			return null;
		}

		private int getWord(int loc) //loc is the low byte
		{
			int lb = (int)romWind.getRom().getByte(loc);
			return ((int)romWind.getRom().getByte(loc+1))*256+lb;
		}

		private void setWord(int loc, int val) //loc is the low byte
		{
			romWind.getRom().setByte(loc,val%256);
			romWind.getRom().setByte(loc+1,val/256);
		}

		private void setAdjust(int adj)
		{
			for(int i = 2; i<32; i+=4)
			{
				int loc = iacvadd + i;
				setWord(loc, getWord(loc)+adj);
			}
		}

		public object mnu_click(params object[] objs)
		{
			int oldadj = getWord(iacvadd+2) - 0x428f;
			dlg = new IACVAdjustDlg();
			dlg.IACVAdjust = oldadj;
			dlg.ShowDialog();

			int adj = dlg.IACVAdjust;
			if(adj != int.MaxValue)
				setAdjust(adj-oldadj); //new adjust

			dlg.Dispose();
			dlg = null;
			return null;
		}
	}//end class
}//end namespace