using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

//css_reference ..\..\bre.exe;

namespace BensScripts
{
	/// <summary>
	/// Summary description for FuelScaleDlg.
	/// </summary>
	public class FuelScaleDlg : System.Windows.Forms.Form
	{
		private const int max = 200;
		private const int min = 0;
		private int val = 100;

		private System.Windows.Forms.CheckBox chkEnable;
		private System.Windows.Forms.GroupBox grpScale;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnApply;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Label labMain;
		private System.Windows.Forms.TextBox txtMain;
		private System.Windows.Forms.Label perc1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public event EventHandler ApplyClicked;
		protected void OnApplyClicked()
		{
			if(ApplyClicked != null)
				ApplyClicked(this, new EventArgs());
		}

		public FuelScaleDlg()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			txtMain.Enabled = false;
		}

		public bool ScalingEnabled
		{
			get{return chkEnable.Checked;}
			set
			{
				chkEnable.Checked = value;
				txtMain.Enabled = value;
				if(!value)
					txtMain.Text = "";
				else
					txtMain.Text = val.ToString();
				//chkEnable.Enabled = !value;
			}
		}
		public int MainFuelScale
		{
			set
			{
				val = value;
				if(val>200)
					val = max;
				if(val<0)
					val = min;
				
				txtMain.Text = val.ToString();
			}
			get
			{
				val = 100;
				try
				{
					val = Convert.ToInt32(txtMain.Text);
				}
				catch{}
				if(val>200)
					return max;
				if(val<0)
					return min;
				return val;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.chkEnable = new System.Windows.Forms.CheckBox();
			this.grpScale = new System.Windows.Forms.GroupBox();
			this.btnOk = new System.Windows.Forms.Button();
			this.btnApply = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.labMain = new System.Windows.Forms.Label();
			this.txtMain = new System.Windows.Forms.TextBox();
			this.perc1 = new System.Windows.Forms.Label();
			this.grpScale.SuspendLayout();
			this.SuspendLayout();
			// 
			// chkEnable
			// 
			this.chkEnable.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.chkEnable.Location = new System.Drawing.Point(24, 32);
			this.chkEnable.Name = "chkEnable";
			this.chkEnable.Size = new System.Drawing.Size(64, 16);
			this.chkEnable.TabIndex = 0;
			this.chkEnable.CheckedChanged += new System.EventHandler(this.chkEn_Checked);
			this.chkEnable.Text = "Enable";
			// 
			// grpScale
			// 
			this.grpScale.Controls.Add(this.perc1);
			this.grpScale.Controls.Add(this.txtMain);
			this.grpScale.Controls.Add(this.labMain);
			this.grpScale.Controls.Add(this.chkEnable);
			this.grpScale.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.grpScale.Location = new System.Drawing.Point(8, 8);
			this.grpScale.Name = "grpScale";
			this.grpScale.Size = new System.Drawing.Size(272, 184);
			this.grpScale.TabIndex = 1;
			this.grpScale.TabStop = false;
			this.grpScale.Text = "Fuel Scaling";
			// 
			// btnOk
			// 
			this.btnOk.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOk.Location = new System.Drawing.Point(216, 208);
			this.btnOk.Name = "btnOk";
			this.btnOk.Size = new System.Drawing.Size(56, 24);
			this.btnOk.TabIndex = 2;
			this.btnOk.Text = "OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// btnApply
			// 
			this.btnApply.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnApply.Location = new System.Drawing.Point(152, 208);
			this.btnApply.Name = "btnApply";
			this.btnApply.Size = new System.Drawing.Size(56, 24);
			this.btnApply.TabIndex = 3;
			this.btnApply.Text = "Apply";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(88, 208);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(56, 24);
			this.btnCancel.TabIndex = 4;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// labMain
			// 
			this.labMain.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.labMain.Location = new System.Drawing.Point(48, 64);
			this.labMain.Name = "labMain";
			this.labMain.Size = new System.Drawing.Size(72, 16);
			this.labMain.TabIndex = 1;
			this.labMain.Text = "Main Adjust:";
			// 
			// txtMain
			// 
			this.txtMain.Location = new System.Drawing.Point(128, 64);
			this.txtMain.Name = "txtMain";
			this.txtMain.Size = new System.Drawing.Size(80, 20);
			this.txtMain.TabIndex = 2;
			this.txtMain.Text = "";
			this.txtMain.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.txtMain_KeyPress);
			// 
			// perc1
			// 
			this.perc1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.perc1.Location = new System.Drawing.Point(216, 64);
			this.perc1.Name = "perc1";
			this.perc1.Size = new System.Drawing.Size(16, 16);
			this.perc1.TabIndex = 3;
			this.perc1.Text = "%";
			// 
			// FuelScaleDlg
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(292, 245);
			this.ControlBox = false;
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnApply);
			this.Controls.Add(this.btnOk);
			this.Controls.Add(this.grpScale);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "FuelScaleDlg";
			this.Text = "Fuel Scaling";
			this.grpScale.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void chkEn_Checked(object sender, System.EventArgs e)
		{
			ScalingEnabled = chkEnable.Checked;
		}

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			btnApply_Click(null,null);
			Close();
		}

		private void btnApply_Click(object sender, System.EventArgs e)
		{
			OnApplyClicked();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void txtMain_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			bre20.Common.handleIntKeyPress((TextBox)sender,e,false);
		}
	}
}
