

using System;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

using bre20;
//css_reference ..\..\bre.exe;
//css_import FuelScaleDlg.cs;

namespace BensScripts
{
	public class FuelScaling
	{
		private static int PR3ADD = 0x33e8;
		private static int EPW0ADD = 0x3ac6;
		private static int JPW0ADD = 0x3aac;
		private child romWind;
		private static int start = 0x502A;
		private static int mainAdd = 0x7ffb;
		private FuelScaleDlg dlg;

		public static object AppliesTo(){return "pr3:pw0";}
		public static object ScriptTitle(){return "Fuel Scaling by Ben Ogle";}

		//args[1] = child window of type bre20.child
		public object ScriptMain(params object[] args)
		{
			romWind = (child)args[1];
		//	string str = romWind.getRomType();
		//	if(Common.isMatch("jdm pw0",str,false))
		//		iacvadd = JPW0ADD;
		//	else if(Common.isMatch("euro pw0",str,false))
		//		iacvadd = EPW0ADD;
		//	else //if(Common.isMatch("pr3",str,false))
		//		iacvadd = PR3ADD;

			MenuItem item = romWind.AddMenuItem("Scripts", "Fuel Scaling...", "BensScripts.FuelScaling.mnu_click");
			return null;
		}

		private int calcReal(int byt)
		{
			return byt*100 / 128;
		}

		private int calcByte(int real)
		{
			return real*128/100;
		}

		private bool isEnabled()
		{
			return (int)romWind.getRom().getByte(start) == 0x44;
		}

		private void setScalingEnabled(bool en)
		{
			if((en && isEnabled()) || (!en && !isEnabled()))
				return;

			string type = romWind.getRomType();
			string chpath = null;
			if(Common.isMatch("jdm pr3",type,false))
				chpath = "\\JPr3FuelScaleT2.txt";
			else if(Common.isMatch("jdm pw0",type,false))
				chpath = "\\JPw0FuelScaleT2.txt";
			else if(Common.isMatch("euro pw0",type,false))
				chpath = "\\EPw0FuelScaleT2.txt";

			if(chpath != null)
			{
				Assembly asm = Assembly.GetAssembly(this.GetType());
				romWind.parseByteChanges(Path.GetDirectoryName(asm.Location) + chpath, en);
			}
		}

		private void btnApply_Click(object sender, System.EventArgs e)
		{
			setScalingEnabled(dlg.ScalingEnabled);
			int newval = calcByte(dlg.MainFuelScale);
			romWind.getRom().setByte(mainAdd,newval); 
			dlg.MainFuelScale = calcReal(newval);
		}

		public object mnu_click(params object[] objs)
		{
			int val = (int)romWind.getRom().getByte(mainAdd);
			val = calcReal(val);

			dlg = new FuelScaleDlg();
			dlg.ApplyClicked += new System.EventHandler(this.btnApply_Click);
			if(isEnabled())
				dlg.MainFuelScale = val;
			dlg.ScalingEnabled = isEnabled();
			dlg.ShowDialog();

			dlg.Dispose();
			dlg = null;
			return null;
		}
	}//end class
}//end namespace